Operators and Symbols
====================

{{#include ../links.md}}


Operators
---------

|     Operator      | Description                    | Binary? | Binding direction |
| :---------------: | ------------------------------ | :-----: | :---------------: |
|        `+`        | add                            |   yes   |       left        |
|        `-`        | subtract, Minus                | yes/no  |       left        |
|        `*`        | multiply                       |   yes   |       left        |
|        `/`        | divide                         |   yes   |       left        |
|        `%`        | modulo                         |   yes   |       left        |
|        `~`        | power                          |   yes   |       left        |
|       `>>`        | right bit-shift                |   yes   |       left        |
|       `<<`        | left bit-shift                 |   yes   |       left        |
|        `&`        | bit-wise _And_, boolean _And_  |   yes   |       left        |
|  <code>\|</code>  | bit-wise _Or_, boolean _Or_    |   yes   |       left        |
|        `^`        | bit-wise _Xor_, boolean _Xor_  |   yes   |       left        |
|       `==`        | equals to                      |   yes   |       left        |
|       `~=`        | not equals to                  |   yes   |       left        |
|        `>`        | greater than                   |   yes   |       left        |
|       `>=`        | greater than or equals to      |   yes   |       left        |
|        `<`        | less than                      |   yes   |       left        |
|       `<=`        | less than or equals to         |   yes   |       left        |
|       `&&`        | boolean _And_ (short-circuits) |   yes   |       left        |
| <code>\|\|</code> | boolean _Or_ (short-circuits)  |   yes   |       left        |
|        `!`        | boolean _Not_                  |   no    |       left        |
|    `[` .. `]`     | indexing                       |   yes   |       right       |
|        `.`        | property access, method call   |   yes   |       right       |


Symbols
-------

| Symbol       | Description              |
| ------------ | ------------------------ |
| `:`          | property value separator |
| `::`         | module path separator    |
| `#`          | _Reserved_               |
| `=>`         | _Reserved_               |
| `->`         | _Reserved_               |
| `<-`         | _Reserved_               |
| `===`        | _Reserved_               |
| `!==`        | _Reserved_               |
| `:=`         | _Reserved_               |
| `::<` .. `>` | _Reserved_               |
| `@`          | _Reserved_               |
| `(*` .. `*)` | _Reserved_               |
